---
policy: /ce/ca/azure/key-vault/role-based-access-control
logic: /ce/ca/azure/key-vault/role-based-access-control/prod.logic.yaml
executionTime: 2025-04-24T23:45:27.741235587Z
rows:
  - id: test1
    match: true
    status:
      expected: DISAPPEARED
      actual: DISAPPEARED
    conditionIndex:
      expected: 99
      actual: 99
    conditionText:
      expected: isDisappeared(CA10__disappearanceTime__c)
      actual: isDisappeared(CA10__disappearanceTime__c)
    runtimeError: {}
  - id: test2
    match: true
    status:
      expected: INCOMPLIANT
      actual: INCOMPLIANT
    conditionIndex:
      expected: 199
      actual: 199
    conditionText:
      expected: extract('CA10__rbacAuthorization__c') == 'Disabled'
      actual: extract('CA10__rbacAuthorization__c') == 'Disabled'
    runtimeError: {}
  - id: test3
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 299
      actual: 299
    conditionText:
      expected: extract('CA10__rbacAuthorization__c') == 'Enabled'
      actual: extract('CA10__rbacAuthorization__c') == 'Enabled'
    runtimeError: {}
usedFiles:
  - path: /ce/ca/azure/key-vault/role-based-access-control/policy.yaml
    md5Hash: B26875302FF114A59286EF5B7C53DD03
    content: |
      ---
      names:
        full: Azure Key Vault Role Based Access Control is not enabled
        contextual: Role Based Access Control is not enabled
      description: "The new RBAC permissions model for Key Vaults enables a much finer grained\
        \ access control for key vault secrets, keys, certificates, etc., than the   vault\
        \ access policy. This in turn will permit the use of privileged identity management\
        \ over these roles, thus securing the key vaults with JIT Access management."
      type: COMPLIANCE_POLICY
      categories:
        - SECURITY
      frameworkMappings:
        - "/frameworks/cis-azure-v2.1.0/08/06"
        - "/frameworks/cis-azure-v3.0.0/03/03/06"
        - "/frameworks/cloudaware/resource-security/secure-access"
      similarPolicies:
        internal:
          - dec-x-c8041456
  - path: /ce/ca/azure/key-vault/role-based-access-control/prod.logic.yaml
    md5Hash: CE5A7EDFA0CEE07BC5137CC0E61D4656
    content: |
      ---
      inputType: "CA10__CaAzureKeyVault__c"
      importExtracts:
        - file: "/types/CA10__CaAzureKeyVault__c/object.extracts.yaml"
      testData:
        - file: "test-data.json"
      conditions:
        - status: "INCOMPLIANT"
          currentStateMessage: "The Azure role-based access control is disabled."
          remediationMessage: "Consider enabling role-based access control."
          check:
            IS_EQUAL:
              left:
                EXTRACT: "CA10__rbacAuthorization__c"
              right:
                TEXT: "Disabled"
        - status: "COMPLIANT"
          currentStateMessage: "The Azure role-based access control is enabled."
          check:
            IS_EQUAL:
              left:
                EXTRACT: "CA10__rbacAuthorization__c"
              right:
                TEXT: "Enabled"
      otherwise:
        status: "UNDETERMINED"
        currentStateMessage: "Unexpected value in the field."
  - path: /types/CA10__CaAzureKeyVault__c/object.extracts.yaml
    md5Hash: 6C8158AF4E8A90E532020A68611A20C7
    content: "---\nextracts:\n# Values: Enabled, Disabled. Not Nullable. Can't have\
      \ no access, retrieved via Microsoft.KeyVault/vaults\n  - name: \"CA10__rbacAuthorization__c\"\
      \n    value: \n      FIELD:\n        path: \"CA10__rbacAuthorization__c\"\n\
      \        undeterminedIf:\n          isEmpty: \"Corrupted data. Key Vault RBAC\
      \ Authorization cannot be empty.\"\n# Values: Enabled, null. Nullable. Can't\
      \ have no access, retrieved via Microsoft.KeyVault/vaults\n  - name: \"CA10__purgeProtection__c\"\
      \n    value: \n      FIELD:\n        path: \"CA10__purgeProtection__c\"\n# Values:\
      \ Enabled, Disabled. Not Nullable. Can't have no access, retrieved via Microsoft.KeyVault/vaults\n\
      \  - name: \"CA10__softDelete__c\"\n    value: \n      FIELD:\n        path:\
      \ \"CA10__softDelete__c\"\n        undeterminedIf:\n          isEmpty: \"Corrupted\
      \ data. Soft Delete function cannot be empty.\"\n"
  - path: /ce/ca/azure/key-vault/role-based-access-control/test-data.json
    md5Hash: 77CAC2CEF593C8012B7436C9F1D385A8
    content: |-
      [
          {
              "expectedResult": {
                  "status": "DISAPPEARED",
                  "conditionIndex": "99",
                  "conditionText": "isDisappeared(CA10__disappearanceTime__c)",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-06-27T20:33:04Z"
              },
              "Id": "test1",
              "CA10__disappearanceTime__c": "2024-06-27T20:33:04Z",
              "CA10__rbacAuthorization__c": "Disabled"
          },
          {
              "expectedResult": {
                  "status": "INCOMPLIANT",
                  "conditionIndex": "199",
                  "conditionText": "extract('CA10__rbacAuthorization__c') == 'Disabled'",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-06-27T20:33:04Z"
              },
              "Id": "test2",
              "CA10__disappearanceTime__c": null,
              "CA10__rbacAuthorization__c": "Disabled"
          },
          {
              "expectedResult": {
                  "status": "COMPLIANT",
                  "conditionIndex": "299",
                  "conditionText": "extract('CA10__rbacAuthorization__c') == 'Enabled'",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-06-27T20:33:04Z"
              },
              "Id": "test3",
              "CA10__disappearanceTime__c": null,
              "CA10__rbacAuthorization__c": "Enabled"
          }
      ]
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "test1",
    "expectedResult" : {
      "status" : "DISAPPEARED",
      "conditionIndex" : "99",
      "conditionText" : "isDisappeared(CA10__disappearanceTime__c)",
      "runtimeError" : null
    }
  }, {
    "Id" : "test2",
    "expectedResult" : {
      "status" : "INCOMPLIANT",
      "conditionIndex" : "199",
      "conditionText" : "extract('CA10__rbacAuthorization__c') == 'Disabled'",
      "runtimeError" : null
    }
  }, {
    "Id" : "test3",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "299",
      "conditionText" : "extract('CA10__rbacAuthorization__c') == 'Enabled'",
      "runtimeError" : null
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10__CaAzureKeyVault__c()
  RETURNS ARRAY<STRUCT<
      Id STRING,
      CA10__disappearanceTime__c TIMESTAMP,
      CA10__rbacAuthorization__c STRING,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2024-06-27T20:33:04Z")
    },
    "Id" : "test1",
    "CA10__disappearanceTime__c" : new Date("2024-06-27T20:33:04Z"),
    "CA10__rbacAuthorization__c" : "Disabled"
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-06-27T20:33:04Z")
    },
    "Id" : "test2",
    "CA10__rbacAuthorization__c" : "Disabled"
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-06-27T20:33:04Z")
    },
    "Id" : "test3",
    "CA10__rbacAuthorization__c" : "Enabled"
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10__CaAzureKeyVault__c(
      obj STRUCT<
          Id STRING,
          CA10__disappearanceTime__c TIMESTAMP,
          CA10__rbacAuthorization__c STRING
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
      var TextLib = new function () {
          this.normalize = function(arg) {
              return arg == null ? '' : arg.replace(/\s+/g, ' ').trim().toLowerCase();
          };
          this.isEmpty = function(arg) {
              return this.normalize(arg) == '';
          };
          this.isNotEmpty = function(arg) {
              return this.normalize(arg) != '';
          };
          this.equal = function(left, right) {
              return this.normalize(left) == this.normalize(right);
          };
          this.notEqual = function(left, right) {
              return this.normalize(left) != this.normalize(right);
          };
          this.startsWith = function(arg, substring) {
              return this.normalize(arg).startsWith(this.normalize(substring));
          };
          this.endsWith = function(arg, substring) {
              return this.normalize(arg).endsWith(this.normalize(substring));
          };
          this.contains = function(arg, substring) {
              return this.normalize(arg).includes(this.normalize(substring));
          };
      }();
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From Azure [CA10__disappearanceTime__c]: ' + obj.CA10__disappearanceTime__c);
      if (obj.CA10__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function fieldChecked4() {
          if (TextLib.isEmpty(obj.CA10__rbacAuthorization__c)) {
              throw new Error("UNDETERMINED condition:101", {cause: {status: 'UNDETERMINED', conditionIndex: 101, conditionText: "CA10__rbacAuthorization__c.isEmpty()", currentStateMessage: "Corrupted data. Key Vault RBAC Authorization cannot be empty.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null}});
          }
          return obj.CA10__rbacAuthorization__c;
      }
      function extract3() { if (!this.out) { this.out = fieldChecked4(); } return this.out; };
      references1.push('RBAC Authorization [obj.CA10__rbacAuthorization__c]: ' + obj.CA10__rbacAuthorization__c);
      try {
          if (TextLib.equal(extract3.call(extract3), 'Disabled')) {
              return {status: 'INCOMPLIANT', conditionIndex: 199, conditionText: "extract('CA10__rbacAuthorization__c') == 'Disabled'", currentStateMessage: "The Azure role-based access control is disabled.", currentStateReferences: references1.join('\n'), remediation: "Consider enabling role-based access control.", runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      // condition[2], conditionIndex:[200..299]
      function fieldChecked7() {
          if (TextLib.isEmpty(obj.CA10__rbacAuthorization__c)) {
              throw new Error("UNDETERMINED condition:201", {cause: {status: 'UNDETERMINED', conditionIndex: 201, conditionText: "CA10__rbacAuthorization__c.isEmpty()", currentStateMessage: "Corrupted data. Key Vault RBAC Authorization cannot be empty.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null}});
          }
          return obj.CA10__rbacAuthorization__c;
      }
      function extract6() { if (!this.out) { this.out = fieldChecked7(); } return this.out; };
      try {
          if (TextLib.equal(extract6.call(extract6), 'Enabled')) {
              return {status: 'COMPLIANT', conditionIndex: 299, conditionText: "extract('CA10__rbacAuthorization__c') == 'Enabled'", currentStateMessage: "The Azure role-based access control is enabled.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      return {status: 'UNDETERMINED', conditionIndex: 300, conditionText: "otherwise", currentStateMessage: "Unexpected value in the field.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.Id AS Id,
          sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
          sObject.CA10__rbacAuthorization__c AS CA10__rbacAuthorization__c,
          process_CA10__CaAzureKeyVault__c(
              STRUCT(
                  sObject.Id AS Id,
                  sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
                  sObject.CA10__rbacAuthorization__c AS CA10__rbacAuthorization__c
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10__CaAzureKeyVault__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
